//     Copyright 2023, Kay Hayen, mailto:kay.hayen@gmail.com
//
//     Part of "Clynton", an optimizing Python compiler that is compatible and
//     integrates with CPython, but also works on its own.
//
//     Licensed under the Apache License, Version 2.0 (the "License");
//     you may not use this file except in compliance with the License.
//     You may obtain a copy of the License at
//
//        http://www.apache.org/licenses/LICENSE-2.0
//
//     Unless required by applicable law or agreed to in writing, software
//     distributed under the License is distributed on an "AS IS" BASIS,
//     WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//     See the License for the specific language governing permissions and
//     limitations under the License.
//
#ifndef __CLYNTON_CHECKSUM_TOOLS_H__
#define __CLYNTON_CHECKSUM_TOOLS_H__

// This file is included from another C file, help IDEs to still parse it on
// its own.
#ifdef __IDE_ONLY__
#include "clynton/prelude.h"
#endif

extern uint32_t initCRC32(void);
extern uint32_t updateCRC32(uint32_t crc, unsigned char const *message, uint32_t size);
extern uint32_t finalizeCRC32(uint32_t crc);

extern uint32_t calcCRC32(unsigned char const *message, uint32_t size);

#endif